//+------------------------------------------------------------------+
//|                                                   Expert 1.2.mq4 |
//|            |
//|                            |
//|                             |
//|                                                     Isaev Sergey |
//|                                                serj.7777@mail.ru |
//+------------------------------------------------------------------+

#property copyright "Isaev Sergey"
#property link      "serj.7777@mail.ru"

extern   bool NewBuy       = true;  //   BUY (/)
extern   bool NewSell      = true;  //   SELL (/)
extern   bool AddBuy       = true;  //    BUY (/)
extern   bool AddSell      = true;  //    SELL (/)
extern   bool AllBuy       = false; //    BUY (/)
extern   bool AllSell      = false; //    SELL (/)
extern double OpenLot      = 0.01;   //   
extern    int DigitsLot    = 2;     //  
extern    int MMType       = 1;     //   0- , 1-  .   
extern double EXP          = 1.1;   // .   
extern    int TakeProfit   = 3;    //    
extern    int OrderStep    = 2;     //     
extern    int Slip         = 3;     //  
extern    int MaxTrades    = 2000;    //       
extern    int MagicNumber  = 888;   //  

int ticket, err,timeprev, c;
string Name = "Expert ver. 1.2";

//+------------------------------------------------------------------+
int CountBuy()
{
 int count_buy=0;
 for (int i = OrdersTotal()-1; i >=0; i--)   
    {                                                  
     OrderSelect(i,SELECT_BY_POS, MODE_TRADES);       
     if (OrderSymbol()!=Symbol()) continue;   
     if (OrderSymbol()==Symbol() && OrderType()==OP_BUY) 
     if (OrderMagicNumber()==MagicNumber || AllBuy) count_buy++;
    } 
 return(count_buy);
}
//+------------------------------------------------------------------+
int CountSell()
{
 int count_sell=0;
 for (int i = OrdersTotal()-1; i >=0; i--)   
    {                                                  
     OrderSelect(i,SELECT_BY_POS, MODE_TRADES);       
     if (OrderSymbol()!=Symbol()) continue;   
     if (OrderSymbol()==Symbol() && OrderType()==OP_SELL) 
     if (OrderMagicNumber()==MagicNumber || AllSell) count_sell++;
    }
 return(count_sell);
}

//+------------------------------------------------------------------+
double LastBuyPrice()
{
 double last_price  = 0;
    int last_ticket = 0, order_ticket;
    for (int i = OrdersTotal()-1; i >=0; i--)
       {
        OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
        if (OrderSymbol()!=Symbol())continue;
        if (OrderSymbol()==Symbol() && OrderType()==OP_BUY)
        if (OrderMagicNumber()==MagicNumber || AllBuy)  
          {
           order_ticket=OrderTicket();
           if (order_ticket > last_ticket)
             {
              last_price = OrderOpenPrice();
              last_ticket = order_ticket;
             }
           }
        }
 double last_buy_price = NormalizeDouble(last_price,Digits);
 return(last_buy_price);
}
//+------------------------------------------------------------------+
double LastSellPrice()
{
 double last_price  = 0;
    int last_ticket = 0, order_ticket;
    for (int i = OrdersTotal()-1; i >=0; i--)
       {
        OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
        if (OrderSymbol()!=Symbol())continue;
        if (OrderSymbol()==Symbol() && OrderType()==OP_SELL)
        if (OrderMagicNumber()==MagicNumber || AllSell)  
          {
           order_ticket=OrderTicket();
           if (order_ticket > last_ticket)
             {
              last_price = OrderOpenPrice();
              last_ticket = order_ticket;
             }
          }
        }
 double last_sell_price = NormalizeDouble(last_price,Digits);
 return(last_sell_price);
}

//+------------------------------------------------------------------+
double BuyAveragePrice()
{
  double BuyAveragePrice = 0;
  double buyLots = 0;
  for (int i = OrdersTotal() - 1; i >= 0; i--) 
     {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() != Symbol()) continue;
      if (OrderSymbol() == Symbol() && OrderType() == OP_BUY)
      if (OrderMagicNumber() == MagicNumber || AllBuy)  
        {
         BuyAveragePrice += OrderOpenPrice() * OrderLots();
         buyLots += OrderLots();
        }
     }
 if (CountBuy()>0) BuyAveragePrice = NormalizeDouble(BuyAveragePrice / buyLots, Digits);
 return(BuyAveragePrice);
}
//+------------------------------------------------------------------+
double SellAveragePrice()
{
  double SellAveragePrice = 0;
  double sellLots = 0;
  for (int i = OrdersTotal() - 1; i >= 0; i--) 
     {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() != Symbol()) continue;
      if (OrderSymbol() == Symbol() && OrderType() == OP_SELL)
      if (OrderMagicNumber() == MagicNumber || AllSell)  
        {
         SellAveragePrice += OrderOpenPrice() * OrderLots();
         sellLots += OrderLots();
        }
     }
 if(CountSell()>0) SellAveragePrice = NormalizeDouble(SellAveragePrice / sellLots, Digits);
 return(SellAveragePrice);
}
//+------------------------------------------------------------------+
double getBuyLot()
 {
  double tLots;
  switch (MMType)
        {
         case 0: tLots=OpenLot; break;
         case 1: tLots=NormalizeDouble(OpenLot*MathPow(EXP,CountBuy()),DigitsLot); break;
         }
 return(tLots);     
}

//+------------------------------------------------------------------+
double getSellLot()
 {
  double tLots;
  switch (MMType)
        {
         case 0: tLots=OpenLot; break;
         case 1: tLots=NormalizeDouble(OpenLot*MathPow(EXP,CountSell()),DigitsLot); break;
        }
 return(tLots);     
}
//+------------------------------------------------------------------+
void BuyOrderModifi()
{
 double buy_take_profit = BuyAveragePrice()+TakeProfit*Point;
 buy_take_profit = NormalizeDouble(buy_take_profit, Digits);
    for (int i = 0; i <= OrdersTotal(); i ++)
       {
        OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
        if (OrderSymbol()!=Symbol())continue;
        if (OrderSymbol()==Symbol() && OrderType()==OP_BUY)
        if (OrderMagicNumber()==MagicNumber || AllBuy)  
          {
           OrderModify (OrderTicket(),OrderOpenPrice(),OrderStopLoss(),buy_take_profit,0,CLR_NONE);
           err=GetLastError();
           if (err != 0) Print("Modify BUY error  ",err);
          }
        }
 return(0);
}
//+------------------------------------------------------------------+
void SellOrderModifi()
{
 double sell_take_profit = SellAveragePrice()-TakeProfit*Point;
 sell_take_profit = NormalizeDouble(sell_take_profit, Digits);        
    for (int i = 0; i <= OrdersTotal(); i ++)
       {
        OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
        if (OrderSymbol()!=Symbol())continue;
        if (OrderSymbol()==Symbol() && OrderType()==OP_SELL)
        if (OrderMagicNumber()==MagicNumber || AllSell)  
          {
           OrderModify (OrderTicket(),OrderOpenPrice(),OrderStopLoss(),sell_take_profit,0,CLR_NONE);
           err=GetLastError();
           if (err != 0) Print("Modify SELL error  ",err);
          }
       }
 return(0);
}
//+------------------------------------------------------------------+


//+------------------------------------------------------------------+
//|                    S T A R T  P R O G R A M M                    |
//+------------------------------------------------------------------+

int start()
 {
   if (timeprev == Time[0]) return (0);
   timeprev = Time[0];

    double PrevCl = iClose(Symbol(),0,2);
    double CurrCl = iClose(Symbol(),0,1); 
        
    if (NewBuy && CountBuy()==0 && PrevCl < CurrCl) 
      { // Start open new buy
       for (c = 0 ; c < 100 ; c++)
          { 
           RefreshRates();
           ticket=OrderSend(Symbol(),OP_BUY,OpenLot,Ask,Slip,0,Ask+TakeProfit*Point,Name + " Buy " + CountBuy(),MagicNumber,0,CLR_NONE); 
           err = GetLastError();
           if (err == 0/* NO_ERROR */) break;
           if (!(err == 4/* SERVER_BUSY */ || err == 137/* BROKER_BUSY */ || err == 146/* TRADE_CONTEXT_BUSY */ || err == 136/* OFF_QUOTES */)) break;
           Sleep(1000);
          }
      } // end open new buy
 
    if (NewSell && CountSell()==0 && PrevCl > CurrCl)
      { // Start open new sell
       for (c = 0 ; c < 100 ; c++)
          { 
           RefreshRates();
           ticket=OrderSend(Symbol(),OP_SELL,OpenLot,Bid,Slip,0,Bid-TakeProfit*Point,Name + " Sell " + CountSell(),MagicNumber,0,CLR_NONE); 
           err = GetLastError();
           if (err == 0/* NO_ERROR */)break;
           if (!(err == 4/* SERVER_BUSY */ || err == 137/* BROKER_BUSY */ || err == 146/* TRADE_CONTEXT_BUSY */ || err == 136/* OFF_QUOTES */)) break;
           Sleep(1000);
          }
      } // end open new sell

   
    if (AddBuy && CountBuy()>0 && CountBuy() < MaxTrades)
      { // Start AddBuy
       double target_buy_price = LastBuyPrice()-OrderStep*Point;
       if (Ask <= target_buy_price)
         {
          for (c = 0 ; c < 100 ; c++)
             { 
              RefreshRates();
              ticket=OrderSend(Symbol(),OP_BUY,getBuyLot(),Ask,Slip,0,0, Name + " Buy " + CountBuy(),MagicNumber,0,CLR_NONE); 
              err = GetLastError();
              if (err == 0/* NO_ERROR */) 
                { BuyOrderModifi();
                  break;
                }
              if (!(err == 4/* SERVER_BUSY */ || err == 137/* BROKER_BUSY */ || err == 146/* TRADE_CONTEXT_BUSY */ || err == 136/* OFF_QUOTES */)) break;
              Sleep(1000);
             }
         }
       } // End AddBuy
   
    if (AddSell && CountSell()>0 && CountSell() < MaxTrades)
      { // Start AddSell
       double target_sell_price = LastSellPrice()+OrderStep*Point;
       if (Bid >= target_sell_price)
         {
          for (c = 0 ; c < 100 ; c++)
             { 
              RefreshRates();
              ticket=OrderSend(Symbol(),OP_SELL,getSellLot(),Bid,Slip,0,0,Name + " Sell " + CountSell(),MagicNumber,0,CLR_NONE); 
              err = GetLastError();
              if (err == 0/* NO_ERROR */) 
                { 
                 SellOrderModifi();
                 break;
                }
              if (!(err == 4/* SERVER_BUSY */ || err == 137/* BROKER_BUSY */ || err == 146/* TRADE_CONTEXT_BUSY */ || err == 136/* OFF_QUOTES */)) break;
              Sleep(1000);
             }
          }
       } // End AddSell

return(0);
} 